/* 
-*- coding: latin-1 -*-

This file is part of RefactorErl.

RefactorErl is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

RefactorErl is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with RefactorErl.  If not, see <http://plc.inf.elte.hu/erlang/>.

The Original Code is RefactorErl.

The Initial Developer of the Original Code is Eötvös Loránd University.
Portions created  by Eötvös Loránd University and ELTE-Soft Ltd.
are Copyright 2007-2023 Eötvös Loránd University, ELTE-Soft Ltd.
and Ericsson Hungary. All Rights Reserved.
*/

package com.refactorerl.ui.logic.queries;

import java.util.List;
import java.util.SortedMap;

public class QueryHistoryElement {
	public QueryHistoryElement(String queryString, String fileName,
			Integer startPos,
			SortedMap<String, List<QueryResultElement>> queryResults) {
	
		this.queryString = queryString;
		this.fileName = fileName;
		this.startPos = startPos;
		this.queryResults = queryResults;
	}
	
	final public String queryString;
	final public String fileName;
	final public Integer startPos;
	final public SortedMap<String, List<QueryResultElement>> queryResults; 
	
	@Override
	public String toString() {
		String str = queryString;
		if(fileName != null)
			str += "/"+ fileName.substring(fileName.lastIndexOf('/') + 1);; //$NON-NLS-1$
		if(startPos != null)
			str += "/"+ startPos; //$NON-NLS-1$
		return str;

		
	}
	
	
}
